Unit zp58e_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc;

function zp58e(N :Integer; X :Extended): Extended;

implementation

function zp58e(N :Integer; X :Extended): Extended;
var
I :Integer;
A,B,C :Extended;
const
ONE :Real = 1.0e0;
TWO :Real = 2.0e0;
label
_10,_20,_30,_40;
begin
{ Result -    ZP58E  FORTRANe }
A := ONE;
B := ONE-X;
if ( N <> 0 ) 
 then goto _10;
C := A;
goto _40;
_10:
if ( N <> 1 ) 
 then goto _20;
C := B;
goto _40;
_20:
for I:=2 to N do
 begin
  C := ((TWO*I-ONE-X)*B-(I-ONE)*A)/I;
  A := B;
  B := C;
_30:
 end;
_40:
Result := C;
exit;
end;

end.
